// Generated by CoffeeScript 2.7.0
(function() {
  var Query, pathScorer, pluckCandidates, scorer, sortCandidates;

  scorer = require('./scorer');

  pathScorer = require('./pathScorer');

  Query = require('./query');

  pluckCandidates = function(a) {
    return a.candidate;
  };

  sortCandidates = function(a, b) {
    return b.score - a.score;
  };

  module.exports = function(candidates, query, options) {
    var bKey, candidate, i, key, len, maxInners, maxResults, score, scoreProvider, scoredCandidates, spotLeft, string, usePathScoring;
    scoredCandidates = [];
    //See also option parsing on main module for default
    ({key, maxResults, maxInners, usePathScoring} = options);
    spotLeft = (maxInners != null) && maxInners > 0 ? maxInners : candidates.length + 1;
    bKey = key != null;
    scoreProvider = usePathScoring ? pathScorer : scorer;
    for (i = 0, len = candidates.length; i < len; i++) {
      candidate = candidates[i];
      string = bKey ? candidate[key] : candidate;
      if (!string) {
        continue;
      }
      score = scoreProvider.score(string, query, options);
      if (score > 0) {
        scoredCandidates.push({candidate, score});
        if (!--spotLeft) {
          break;
        }
      }
    }
    // Sort scores in descending order
    scoredCandidates.sort(sortCandidates);
    //Extract original candidate
    candidates = scoredCandidates.map(pluckCandidates);
    if (maxResults != null) {
      //Trim to maxResults if specified
      candidates = candidates.slice(0, maxResults);
    }
    //And return
    return candidates;
  };

}).call(this);
