// Generated by CoffeeScript 2.7.0
(function() {
    // Query object

  // Allow to reuse some quantities computed from query.
  // Optional char can optionally be specified in the form of a regular expression.

  var Query, coreChars, countDir, getCharCodes, getExtension, opt_char_re, truncatedUpperCase;

  ({countDir, getExtension} = require("./pathScorer"));

  module.exports = Query = class Query {
    constructor(query, {optCharRegEx, pathSeparator} = {}) {
      if (!(query && query.length)) {
        return null;
      }
      this.query = query;
      this.query_lw = query.toLowerCase();
      this.core = coreChars(query, optCharRegEx);
      this.core_lw = this.core.toLowerCase();
      this.core_up = truncatedUpperCase(this.core);
      this.depth = countDir(query, query.length, pathSeparator);
      this.ext = getExtension(this.query_lw);
      this.charCodes = getCharCodes(this.query_lw);
    }

  };

  
  // Optional chars
  // Those char improve the score if present, but will not block the match (score=0) if absent.
  opt_char_re = /[ _\-:\/\\]/g;

  coreChars = function(query, optCharRegEx = opt_char_re) {
    return query.replace(optCharRegEx, '');
  };

  
  // Truncated Upper Case:
  // --------------------

  // A fundamental mechanic is that we are able to keep uppercase and lowercase variant of the strings in sync.
  // For that we assume uppercase and lowercase version of the string have the same length. Of course unicode being unicode there's exceptions.
  // See ftp://ftp.unicode.org/Public/UCD/latest/ucd/SpecialCasing.txt for the list

  // "Stra�e".toUpperCase() -> "STRASSE"
  // truncatedUpperCase("Stra�e") -> "STRASE"
  // iterating over every character, getting uppercase variant and getting first char of that.

  truncatedUpperCase = function(str) {
    var char, j, len1, upper;
    upper = "";
    for (j = 0, len1 = str.length; j < len1; j++) {
      char = str[j];
      upper += char.toUpperCase()[0];
    }
    return upper;
  };

  
  // Get character codes:
  // --------------------

  // Get character codes map for a given string

  getCharCodes = function(str) {
    var charCodes, i, len;
    len = str.length;
    i = -1;
    charCodes = [];
    // create map
    while (++i < len) {
      charCodes[str.charCodeAt(i)] = true;
    }
    return charCodes;
  };

}).call(this);
